--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-13

[Fixed Bugs]

- [Pen Tablet Control]: The layer selection and move action(Shift+Ctrl+Drag) now performs only layer selection.
- [Pen Tablet Control]: Right-click functionality fails on devices that require pressing the side switch while pressing the pen tip.
  (Apologies; this was a regression introduced in the 2026-08-05 version.)

- [Text Layer]: History operations and saving fail to execute correctly when [Spc.] or [Lift] values are negative.

- [Eyedropper]: Shortcut assignments for [Pick Color from Merged Image] and [Pick Color from Current layer] do not work correctly.
- [Eyedropper]: The eyedropper function within selection brushes fails to work correctly when a layer mask is selected.
  (This was another regression introduced in the 2026-08-06 version. I apologize for the oversight...)

- [Window Control]: Changing [Scaling of User Interface] while the window is maximized causes the window to resize but prevents the UI elements from being repositioned.

- [Window Control]: The layout becomes distorted if the "Scale and layout" setting (text, apps, and other items) in Windows display settings is not set to a multiple of 50%.


[Changes]

- [Keyboard Operation]: Canceled applying [Suppression of Accidental Operation] to [Lasso], [Lasso Fill], [Magic Wand], and [Bucket] tools.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-11

[Fixed Bugs]

- [File Viewer]: Files with uppercase extensions do not appear in the file list.

- [View]: A warning about drawing on an invisible layer appears repeatedly when dragging with a pen.
  (Apologies; this bug was introduced in the 2026-08-05 version.)

- [Merge Layers]: Disabling the paper texture setting is not correctly reflected on the control panel.

- [Magic Wand type tools]: Multiple "Internal state inconsistency" error pop-ups appear under certain conditions.

- [Lasso type tools]: The opacity of the reference color in "Similar Color" mode affects the selection in "Transparent Area" mode.

- [Text tool]: Dragging to adjust font size or line gap values does not work correctly when the printing resolution is not 72 ppi.

- [Effect Pen/Scatter tools]: An access violation occurs when used on a grayscale canvas.

- [Effect Pen/Scatter tools]: The drawing color is not applied correctly on a grayscale canvas.

- [Transformation]: The selection region on blank space is not erased when starting transformation.
  (Apologies; this bug was introduced in the 2026-08-05 version.)

- [Asset Manager]: Thumbnails for registered images may not display correctly after registering multiple images for a scatter shape.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-06

[Fixed Bugs]

- [Floater]: Moving a floater with a paper texture applied caused numerous access violations.

- [Eyedropper]: When dragging with the right button while hovering with a pen, [Pick Color in Dragging] setting is not applied.

- [Pixel Art Pen]: [Target for Dropper] in Eyedropper tool takes precedence over [Layer ARGB] mode for [Dropper].

[Changes]

- [Eyedropper]: Changed to update the brush preview while dragging.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-08-05

[Fixed Bugs]

- [PNG File]: Attempting to open a non-existent PNG file causes an access violation, after which the application begins to malfunction.

- [Text Layer]: Undo or Redo the duplication of a text layer may fail depending on the caret position.

- [Stroke Stabilizer]: Stabilization is not applied if a drag operation is started while holding a modifier key within the time limit
  specified in [Options] > [Keyboard Operation] > [Suppression of Accidental Operation].

- [Pen Tablet Control]: Drag operations no longer accept buffered input when using WinTab API mode.
  (It seems that the generation order between mouse messages and post messages was changed in some version of Windows.)

- [Brush Tools]:  If a brush texture name contains a "%" character, the name is saved to the tool settings with the "%" removed.
  (The next time select the tool, the brush texture is not selected correctly.)

- [Effect Pen / Scatter Tool]: Drawing on a layer mask does not produce the correct color.

- [Scatter Tool]: Nothing is drawn when the shape is set to [Standard Circle].
  (Apologies; this bug was introduced in the 2026-07-29 version.)

- [Scatter Shape / Scatter Tool]: The angle is incorrect when the [Angle] setting is -129 degrees or lower, or +128 degrees or higher.

- [Magic Wand Tool / Bucket Tool]: The application may freeze when selecting or filling a loop-shaped region.

- [Transformation]: Disabling the ruler is not reflected when using grid rulers or symmetry rulers.

- [Transformation]: Confirming or canceling the transformation of a floater with layer effects applied causes the effect to be lost or results in an access violation.


[Changes]

- [Magic Wand Tool / Bucket Tool]: Reverted the change intended to reduce unfilled regions when handling line art with soft edges.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-30

[Fixed Bugs]

- [System File Dialog]: Saving after removing the file extension in the filename field always results in the SAI2 format.

- [Brush Tools]: Inverting the values of the blot map and brush texture does not result in the correct density when drawing.

- [Magic Wand Tool / Bucket Tool]: Area detection fails to function correctly.
  (Apologies; this bug was introduced in the 2026-07-29 version.)

- [Options Dialog]: HSV/HSL sliders do not update correctly when the numerical display range for HSV/HSL is changed.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-29

[Fixed Bugs]

- [Command-line Arguments]: The feature that sends command-line arguments to an existing instance when the program is launched doubly is not working.

- [PSD/PSB Saving]: Layer masks are saved with a horizontal shift (offset to the left or right).

- [View]: Access violations could occur for unknown reasons.
  (The cause remains unknown as the issue could not be reproduced, but measures have been taken to prevent access violations.)

- [Scratchpad]: Cannot paint with a pen tablet.

- [Binary Halftone]: The layer image will disappear when duplicating a layer with halftone settings applied.

- [Layer Moving]: When moved a layer mask for a layer folder that containing child layers, the operation cannot be undone.

- [Perspective Ruler / Perspective Grid / Paper Grid]: Undo/Redo operations were reverting the enabled state of vanishing points and grid snapping settings.

- [Symmetry Ruler]: When transform image with single-axis symmetry or a two-division setting, parts of the image along the axis may be lacked.

- [Magic Wand Tool / Bucket Tool]: When [Dilation Width] is specified, border-like artifacts will appear in the area slightly surrounding the selection or fill.

- [Magic Wand Tool / Bucket Tool]: When [Selection Mode] is [Transparent Area] and anti-aliasing is turned off, the selection or fill will slightly encroach upon opaque areas.

- [Magic Wand Tool]:  [Operation] setting was not being applied.

- [Bucket Tool]: When filling with a transparent color using a different layer as the selection source, existing transparent regions are not detected in the region selection.

- [Brush Tools]: Images assigned to Setting 3 for scattering form fails to render.

- [Curve / Polyline Tools]: The brush circle was not displaying.

- [Color Adjustment Filters]: Yet again, the filters does not work for layer folders.
  (Apologies; this regression was introduced in the fix from the 2026-07-27 version.)


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-27

[Fixed Bugs]

- [Color Management]: Images are saved with ICC color profile applied.

- [View]: Access violations occur when hovering the mouse cursor over deferred updating area while using selection-type tools.

- [Clipboard]: An access violation occurs upon program exit if a shape-type layer is stored in the clipboard.

- [Water Fringe]: In Grayscale mode, an edge is drawn around areas filled with a solid color.

- [Binary Halftone]: In Grayscale mode, stray artifacts appear around drawn areas.

- [Text Layer]: Various minor issues exist, such as the inability to change text color immediately after creation and the origin point shifting during image transformation.

- [Eyedropper]: While a selection-type brush is active, the shortcut keys assigned to [Pick Color from Merged Image] and [Pick Color from Current layer]
  trigger the selection brush picking action instead of the color picking action.

- [Brush Tools]: Brush size cannot be changed using Ctrl+Alt+Drag on layers other than standard layers.

- [Brush Tools]: The bug fix for the fine brush from the 2026-07-02 version applies to non-Ver.1-style brush tools as well.

- [Brush Tools]: When using the Ver.1 stabilizer mode, if the stylus is quickly lifted away from the detection surface, the drag state remains active.

- [Transformation]: Transforming a floater while Water Fringe is enabled causes an access violation, after which the program ceases to function correctly.

- [Change Canvas Resolution]: Changes in resolution were not reflected in Water Fringe width, halftone LPI, or paper texture scale.

- [Color Adjustment Filters]: These could be applied to layers other than normal layers, causing an access violation.
 (The correct specification is that they cannot be applied to layers other than normal layers.)

- [Drawing Filters] An access violation occurs when applying [Outline] and [Gaussian blur] when Water Fringe is specified.

And fixed other minor bugs.


[Changes]

- [Selection Tools]: Added settings to specify selection operations (replace, add, remove, etc.)


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-12

[Fixed Bugs]

- [File Viewer]: Saving sometimes fails even after pressing the save button.

- [Layer Mask]: Watercolor tool painting is incorrect.

- [View]: The drag and drop copy operation from the layer list to an inactive view is not implemented.

- [Lasso type tools]: Program freezes when [Selection Mode] is set to [Polygon] or [Polygon + Freeform].

- [Lasso Fill]: Selection regions are not applied.

- [Binary Brushes]: When [Pick Color in Dragging] is enabled, dragging with the eyedropper causes rapid toggling between the foreground color and transparent.

- [Brush Texture]: The texture density is incorrect is [Invert] is turned on.


[Changes]

- [Lasso Selection Tool]: Changed the selection operation without modifier keys from "replace selection" to "add selection."

- [Brush Tool]: Adjusted default parameters to make it easier to achieve density even with pen pressure.
  (When I used it with the default settings for the first time in a while, it felt like it might give me tendonitis!)

- [Bucket Tool]: Added [Pass Through Selections] that revert behavior to 2026-07-02b versions or earlier.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-11

[Fixed Bugs]

- [Layer List]: Selecting multiple layer while holding the Ctrl key caused the scroll position to always reset to the current layer.

- [Color Mode Change]: The function did not work correctly if there were layers extending outside the canvas boundaries.

- [Text Layer]: Out of memory errors occurred when using certain fonts.
  (This issue occurred with fonts containing a large number of glyph names in the 'post' table as defined by the OpenType specification.)

- [Lasso Selection Tool / Lasso Fill Tool]: Frequent freezing occurred.

- [Text Tool]: Keyboard input focus handling within the floating view did not function correctly.

- [Brush Tools]: Pressing the right mouse button while left-dragging (or vice versa) caused the mouse capture state to fail to release.

- [Brush Tools]: When drawing straight lines while holding the Shift key, the guide snapped at 45-degree increments.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-08

[Fixed Bugs]

- [File Menu]: The canvas editing state(i.e. whether a save operation was possible)) does not relect to [Save] command.

- [File Menu]: The system file dialog is not used even if [Always Use FileViewer] is turned off.

- [Clipboard]: Copying or cutting a selected layer folder consumed excessive memory, resulting in an error.

- [Layer Paper]: Settings were not applied to layer folders.

- [Shape Layer]: Shapes became transparent when loading a canvas created in a version prior to the major renovation.

- [Text Layer]: Malfunctions occurred—such as access violations—when an invalid font was used.

- [Lasso Tool]: Dragging from within the selected area always resulted in deselecting the area, even when holding Shift or Alt.

- [Magic Wand Tool]: The mouse cursor differed from the one used prior to the major overhaul.

- [Text Tool]: Some fonts appeared with blank names in the font list.
  (Support for CFF fonts is not currently implemented, causing their names to appear blank.
  As a temporary measure, these are now displayed in red and treated as invalid fonts.)

- [Brush Tools]: The end of stroke is interupted when using the Ver.1 style stabilizer.

- [Shape Tool]: Creating a shape resulted in the creation of 31 copies of the same layer.
  (This was a regression caused by the fix for the "light-touch drag" issue in the 2026-07-06 version.)

- [Brush Tools]: The brush circle did not redraw when changing the brush size via keyboard shortcuts.

- [Transformation]: Adjusting the perspective slider triggered numerous access violation errors.
  (Note to self: Exceptions occurring within a timer procedure specified by SetTimer() do not cause the application to terminate.)

- [Layer Fill/Erase]: Could not be applied to layer folders.

- [Merge Layers]: Adjustments to layer opacity or special effects were not reflected in the layer list items.

- [Change Canvas Resolution]: There are several bugs, such as access violations and the occurrence of artifacts.

- [Color Adjustment Filters]: Cannot be applied to layer folders.

- [Recently Files]: Memory leak occurs if a non-existent path is present.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-06

[Fixed Bugs]

- [Tools]: Repeated dragging with a very light touch sometimes fail to detect drag operations.

- [PSD/PSB Saving]: Saving a canvas containing layer masks as a PSD/PSB file resulted in an invalid file.

- [Image Save Dialog]: An access violation occurs when selecting [Original Image] for a canvas where the height  exceeded the width.

- [View]: The Eyedropper tool was not functioning on inactive views.

- [Layer Paper]: The tonal values ​​of the texture were inverted.
  (Water fringe functions had been incorrectly applied.)

- [Layer Mask]: [Erase Layer] and [Fill] are always applied to the owner layer of the layer mask.

- [Lasso Selection Tool / Lasso Fill Tool]: Anti-aliasing was being applied even when the setting was turned off.

- [Lasso Fill Tool]: The application freezes when filling a enclosed area with transparent.

- [Effect Pen]: The tool will paint with invalid color values for grayscale mode.

- [Inking Layer: Change Color Tool]: Color changes were not being applied to strokes on a linework layer.

- [Transformation]: An access violation occurs when confirmed transformation if [Water Fringe] was specified.

- [Change Canvas Resolution]: Access violations occur with depending on the combination of original and new sizes.

- [Options Dialog]: [Minimum Pressure] in [Pen Tablet] page does not work for [Use WinTab API] and [Use Windows API].

- [Options Dialog]: [The Store Location of History/Recovery Data and Image File Thumbnails] in [Environment] page is not applied.


[Others]
Added a mention about the limit on the number of layers into [Other Changes] in 2026-07-02 section in this text.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-05

[Fixed Bugs]

- [Canvas]: Depending on the environment, an error may pop up during operations that involve creating a canvas.
  (The cause was a misunderstanding regarding the ICC profile API)

- [PSD/PSB Saving]: Saving a canvas containing layer folders as a PSD or PSB file results in an corrupted file.

- [PSD/PSB Loading]: If color component identification information is missing from the end of layer folder information,
  the file cannot be loaded with "Unsupported channel combination" error.

- [Image Save Dialog]: An access violation occurs when the image save dialog is displayed while a selection region is displayed as color.
  (The cause was a bug in Visual C++)

- [Ruler] [Reset Ruler] does not work.

- [HSV/HS Slider] 'H' value is not updated.

- [Brush Tools] [Use Dot Cursor for Brush Tools] deos not work.

- [Full Screen Mode] The window image becomes corrupted when switching between normal mode and full-screen mode.

- [Options Dialog]: Cannot specify a non-existent path for [The Store Location of History/Recovery Data and Image File Thumbnails] in [Environment] page.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-04

[Fixed Bugs]

- [Canvas]: An operation involving canvas creation fails due to an error.
  (This issue appears to occur in environments where the monitor ICC profile cannot be used.
  In this version, all errors related to the monitor ICC profile are reported via pop-up notifications to assist with data collection.
  If you encounter an error pop-up during a process that involves creating a canvas, we would appreciate it if you could provide the error log.)

- [JPEG]: Cannot open the JPEG file.

- [SelErs tool]: It s behaving the same way as the [SelPen] tool.

- [Edit menu]: Paste operations is not working.
- [Brush tools]: Shortcut keys for changing brush size or density are not working.
- [Linework Layer and Shape Layer]: [Deselect All CPs] in the [Selection] menu is not working.
  (I am sorry, I just forgot to implement it.)

- [English Version]: Some text has not been translated.

I fixed the bugs that required immediate attention and could be resolved right away.
Please allow a little more time for the remaining bugs to be fixed.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02b

[Fixed Bugs]

- [License] Almost license certificates are not correctly recognized.


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02

Major Renovation Version released.

*** Translated by Google Translator and partially modified ***

--------------------------------------------------
■ Important Notes (Updated 2026-07-08)
--------------------------------------------------

The following data created in this major update version (or later) are incompatible in older versions:
・Recovery data for works
・Shortcut key settings (saved as separate setting data from that of older versions)

Starting with this major update version, the supported OS is Windows Vista or later, and a CPU with SSE 4.1 support is required.

----------------------------------
Recreated Features
----------------------------------

[File Viewer]
- Asynchronous processing for updating displayed content
　(reducing instances where the system becomes unresponsive)

- Faster thumbnail updates

- Added a function to view files using only the file system API
　(this can be specified in the [File Viewer] section of the [Operation Details] page in the [Settings] dialog)

[View]
- Improved and stabilized responsiveness of operations

[Lasso tool]
- Added a function to select only closed areas.

[Magic Wand tool]
- The leak prevention algorithm has been revamped
(the previous method was incompatible with the newly created closed-region selection, so a change was necessary.
The new method struggles with intricate shapes, but it should produce better results with neat line drawings).

[Text Tool]
- Added functions to adjust character spacing and line spacing.
- Added ruby annotation function.
- Added Horizontal in Vertical text function.
- Supports bidirectional writing systems such as Arabic.
- Supports image transformation (however, only scaling, shearing, and rotation are supported)

(Since the font driver was implemented in-house, there are currently concerns about stability (such as fault tolerance to corrupted font files).)
(Variable fonts and CFF fonts are not supported.)
(Indian writing systems are not yet supported.)

[Image Transform feature]
- Implemented grid deformation (quadratic Bézier surfaces) and mesh deformation (spline surfaces).
- Implemented symmetric transformation when the symmetry ruler is enabled
　(by enabling the symmetry ruler with one division and no line symmetry and rotating, it can be applied to the rotation of the original deformation range).


----------------------------------
Added Features
----------------------------------

[Grayscale Mode]
- Can be selected as a color mode when creating a canvas.
- Can be changed in the [Color Mode] section of the [Canvas] menu.

[Simple Color Management]
- Added a function to apply the sRGB ICC profile to color images and the sGray ICC profile to grayscale images.
- The ICC profile of the loaded image will be retained
(this is a preliminary implementation; we plan to enhance this functionality in the future).

[User Interface Color feature]
- You can choose between a white-based color scheme and a dark-based color scheme
(you can change this from [Window Color Scheme] in the [Window] menu).

[Paper grid]
- Allows you to specify spacing and top, bottom, left, and right margins.
- Enables snapping operations for brush drawing, shape editing, and image transformation

(can be created from the ruler-type layer creation menu in the layer operation panel).

[Binary Halftone]
- You can specify the shape, number of lines, and angle.
- Shapes include circle, textured, rhombus, ellipse, straight line, square, and cross

(selectable as a special effect for layers).

[Lasso Fill tool]
(This is a fill-type version of the lasso selection tool. It will not be automatically added to the tools section, so please create it manually from the tool creation menu.)

[Asset Registration Function]
- Added functionality to register canvas image as Layer Paper, Brush form, Scatter Shape, and Brush Texture
　(The add button is located at the bottom of the selection popup for each asset).


----------------------------------
 Other Changes
----------------------------------

[Layer Management] (Updated 2026-07-06)
- Removed the limit on the number of layers.

[Layer Mask] (Updated 2026-07-31)
- Implemented simultaneous operation for layers and layer masks
  (This applies to cutting, copying, and image transformations. To manipulate layers and layer masks independently, please follow the steps below.
  - Disable the link between the layer and the layer mask.
  - In the layer list, hold down Alt key and click the thumbnail of the layer or layer mask to highlight it with a blue border.)

[Export]
- Implemented the ability to change the image size when saving.
- Pixel format can be specified for formats other than SAI2, PSD, and JPEG.

[Color Circle]
- Changed to allow resizing.

[Scatter Tool]
- Modified to allow the use of multiple images.
- Modified to allow the use of color images

. (Multiple images can now have their scattering settings changed for each group. A maximum of three groups can be created and edited in the [Materials & Tools Management] dialog.)

[Linework Layer and Shape Layer]
- Improved the quality of curve curvature.
- Modified to allow cutting and copying in the same way as normal layers.
- Changed the first and last control points to triangular arrows to indicate the direction of the path.

[Shape Layer]
- Added a function to add outlines to shapes
　(can be specified using the Curve Tool, Polyline Tool, and Shape Modification Tool)
- Added a function to round off the corners of polylines
　(can be specified using the Curve Tool, Polyline Tool, Corner Rounding Tool, and Shape Modification Tool)
- Added a function to transfer paths between shapes
　(drag a control point to the curve or fill portion of another shape while holding down Shift+Ctrl)

(I forgot to add the function to reverse path direction and change the overlapping order...)

[Ruler]
- When a paper grid or perspective grid is enabled, rulers will now snap to the grid when displayed
　(ruler placement is remembered in the paper grid or perspective grid).

[Assign shortcut keys]
- Changed the setting so that shift operation can be individually turned ON/OFF (only for functions that support shift operation).

*** Translated by Google Translator and partially modified ***


--------------------------------------------------------------------------------------------------------------------------------------------
2026-07-02

This is the last stable version before the major renovation.

[Fixed Bugs]

- [New Tool Creation]: "Blur" in "Ver.1 Like" group will create a Ver.2 [Blur] tool instead of a [Water Color] based tool.

- [Brush Tools]: The lines drawn around the line width of 1.0 with the Ver.1 like tools are slightly thinner than in SAI Ver.1.

- [Gradation Tool] When using Gradation Tool with "Tool Shift" and selecting OK or Cancel, the program does not function properly.


[Changes]

- [Settings Files]: Improved the recovery operations from file corruption errors.

- [Options Dialog]: Discontinued [A. Assign CPU cores to achieve the fastest response if the system is not loaded].
  (This is due to a series of reports of symptoms in which the Windows 11 system continuously puts constant strain on the CPU)

- [Tool Preference] Reverted to the format embedded in the brush panel from the version prior to 2019-08-12 version.
  (I had made this change in anticipation of a significant increase in parameters,
   but I realized that only a few additional parameters were needed, so I reverted it.)


And some other minor changes and some minor bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2024-11-23

[Fixed Bugs]

- [Initialization]: The program is unable to start with an error if [Store Location of History/Recovery Data and Image File Thumbnails]
                    in the settings file is invalid path.
  (For example, this problem can occur if copied the settings file from another computer)


[Changes]

- [Options Dialog]: Added a brief explanation of how to use [CPU Cores Assignment].

- [History]: Changed to create a file with a named in the format "__<CANVAS_FILENAME>.txt".
  (The contents of this file is the full path for the canvas file)


And some other minor changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2024-08-14

[Fixed Bugs]

- [Windows Control]: When invoke a time-consuming operation by a shortcut key with modifier keys, the modifier keys may remain pressed.

- [Brush Tools]: When [Display the brush circle in the true painting size] is turning on,
                 the minimum size circle continues to be displayed even if the minimum pen pressure is disabled.


--------------------------------------------------------------------------------------------------------------------------------------------
2024-07-19

[Fixed Bugs]

- [Binary Brushes]: If a symmetric ruler is enabled, the first pixel of a stroke will not be drawn.

- [File Viewer]: When dragged files to a folder shortcut in the file list, files are always moved to the folder where sai2.exe is located.

- [Windows Control]: The window may black out when performing processing that takes a long time (such as saving or loading a large file).


--------------------------------------------------------------------------------------------------------------------------------------------
2024-05-22

[Fixed Bugs]

- [Symmetric Ruler]: The painting details of binary brush tools are not symmetric.

- [File Viewer]: Access violations occur if a thumbnail cache file is corrupted.

- [Pen Tablet Control]: If [Pen Tablet control API] is Windows API, suppression for the short delay when starting pen drag is not working.


[Changes]

- [Binary Pen]: Changed the painting color specification for layer masks to be the same as other brush tools.

- [File Viewer]: Changed to delete once the thumbnail cache file when processing [Update All Thumbnails].


And some other minor changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2024-04-10

[Fixed Bugs]

- [Pen Tablet Control]: If [Pen Tablet control API] is Windows API, popup menus and dropdown lists cannot be operated by pen.


--------------------------------------------------------------------------------------------------------------------------------------------
2024-04-07

[Fixed Bugs]

- [Pen Tablet Control]: If [Pen Tablet control API] is WinTab API, SAI may stop user input when the window is activated by pen.

- [Options Dialog]: [CPU Assignment] in [Environment] page does not work properly.

- [File Viewer]: Right-click immediately after left-click works as a double-click in the file list pane.


[Changes]

- [Options Dialog]: Added a setting to reduce CPU core using to [CPU Assignment] section in [Environment] page.

- [Layer List]: Changed the layer selection shortcut to prioritize the last feature(layer or layer mask) selected by mouse.

- [Shortcut Keys dialog]: Added [Select/Deselect Layer Mask] into [Layer Settings] group.


And some other minor changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2024-02-22

[Fixed Bugs]

- [Asset Popup]: The layout of group pane is corrupted if the number of groups exceeds 15.

- [Asset Popup]: If manipulate a scroll bar even once, the asset thumbnails will no longer be updated immediately when select a group.

- [Perspective Grid]: A perspective grid is able to placed on the axis plane of a 1vp perspective ruler, 
                      but the grid become impossible to operate.

- [Window Control]: The first click is not ignored when activate a window.
  (This bug was added in 2023-11-20 version)

- [Popup List]: When operate the scroll bar and then click outside the list to cancel, the click is ignored once.
  (This bug was not fixed correctly in 2023-11-20 version)


[Changes]

- [Layer Mask]: Changed to the layer mask is not selected preferentially when selecting a layer folder that has a layer mask.

- [Bristle]: Changed to display an error and make it unusable when selecting a bristle that has hair points more than 63.

- [Curve tool and Line tool]: Changed to be able to apply a symmetric ruler.

- [File Viewer]: Changed to ignore shell namespace items that occurring error.


And some other minor changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2023-11-20

[Fixed Bugs]

- [Inter Thread Communication]: Memory corruption or access violation occur in rare cases during some functions.

- [Binary Eraser]: [Preserve Pixel Opacity] is ignored.

- [Syringe]: The use layer mask switch in the layer list is ignored.

- [Options Dialog]: Renovated [Process Execution Priority] section in [Environment] page.
  (Added [CPU Assignment] setting, changed the section name to [Countermeasure when Program is Poor Responsivity],
   and updated the explanation)

- [Popup List]: When operate the scroll bar and then click outside the list to cancel, the click is ignored once.


[Changes]

- [Menu Bar]: Changed to be able to open hidden menu bar items using access keys.


And some other minor changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2023-07-11

[Fixed Bugs]

- [Linework Layer and Shape Layer]: In rare case, the order of  shapes is recorded incorrectly when creating a recovery point,.

- [Options Dialog]: [The Store Location of History/Recovery Data and Image File Thumbnails] accepts a null string.


[Changes]

- [Vanishing Point Ruler and Symmetric Ruler]: Changed so that Shift+Ctrl+drag can also start "Move" operation.


--------------------------------------------------------------------------------------------------------------------------------------------
2023-04-05

[Changes]

- [Multi-core operation]: Modified CPU asignment.


--------------------------------------------------------------------------------------------------------------------------------------------
2023-04-02

[Fixed Bugs]

- [Eraser Tool(for Linework)]: Invisible linework layers are also erased when erasing multiple layers.

- [Vector Graphics]: The outlines of text layers, rulers, etc. are slightly jagged.

- [View]: The zooming center shifts when zoomed down to 50% or less.

- [Filter: Gaussian Blur]: The result is incorrect  when applied to layer mask.


[Changes]

- [Zoom Tool]: Added a setting to change the drag direction of scrub zoom from horizontal to vertical.

- [Symmetric Ruler]: Added a setting to select the ruler center alignment by pixel center or pixel boundary.
  (Can be specified from the context menu of Symmetric Ruler(Ctrl + Right Click Dividing Line))


--------------------------------------------------------------------------------------------------------------------------------------------
2022-12-01

[Fixed Bugs]

- [Asset Manager]: Cannot rename scratch pads.

- [Layer Panel]: Drag operation is canceled when the mouse cursor passed over a layer operation button.

- [Vanishing Point Rluer]: The hit test range for ruler moving varies with the view scale.


--------------------------------------------------------------------------------------------------------------------------------------------
2022-08-28

[Fixed Bugs]

- [Text Layer]: Editing text outside the canvas may cause an access violation.

- [Text Layer]: Rendering results may e corrupted outside the canvas.

- [History]: Closing the canvas immediately after editing may cause an access violation.


--------------------------------------------------------------------------------------------------------------------------------------------
2022-05-27

[Fixed Bugs]

- [Rulers]: On particular environment, the mouse cursor and guide lines are delayed if [Pen Tablet Control API] is [Use Windows API].

- [Smudge Tool]: The checkbox of [Coloring] will be turned off when restart program.

- [Layer Transform]: The image outside 32768 x 32768 will lost.

- [Straight Line Ruler/Parallel Line Ruler]: The hit test for ruler moving is fixed as the range of 96dpi even in high DPI environments.


--------------------------------------------------------------------------------------------------------------------------------------------
2022-02-07

[Fixed Bugs]

- [Menus and Popop Lists]: On Windows 7 or earlier, unable to close a menu or a popup list by mouse click.

- [Outline Drawing]: Unable to draw outline correctly if the drawing range is aligned to 32px boundaries.

- [Transform Layer]: Nudge, Reverse and Rotate 90deg. are applied in the rotated angle of the transform guide.


[Changes]

- [Rulers]: Changed to disable ruler operation while [Temporarily Ignore Ruler] is turning on.
  (This is a change to enable the straight line drawing by Shift+Click in brush tools while ruler is ignored)


--------------------------------------------------------------------------------------------------------------------------------------------
2022-01-05

[Fixed Bugs]

- [Water Color]: The blur effect is smoother compare to Ver.1.

- [Brush Type Tools]: The blending effect has become slightly stronger by the fix on 2021-12-30 version.


--------------------------------------------------------------------------------------------------------------------------------------------
2021-12-30

[Fixed Bugs]

- [Window Control]: [Move] and [Size] in the system menu opend on the title bar does not work on Windows 8 or later.

- [Tool Group]: The tool group selection at starting is fixed to [Unorg] group after selected [Unorg] group and closed program.

- [Water Color]: The blur effect is flatten compare to Ver.1.

- [Brush Type Tools]: Improved controllability of light coloring with weak pen pressure.

- [Edit Tool for Linework Layer]: [Connect CPs] malfunctions when multiple paths are selected.


[Changes]

- [Edit Menu]: Added [Paste without Deselecting].


--------------------------------------------------------------------------------------------------------------------------------------------
2021-10-06

[Fixed Bugs]

- [Brush Tools] The brush circle and guide lines are delayed while using a pen tablet.

- [Swatches and Scrach Pad] An accsess violation occurs when picked a color.


--------------------------------------------------------------------------------------------------------------------------------------------
2021-10-05

[Fixed Bugs]

- [Color History] A color slightly different from the original color is registered.

- [Selection Region] Vertical streaks appear when created a selection region by clicking a layer thumbnail.

- [Syringe] The syringe by shortcut key does not work on the scratchpad.

- [Custom Tools] After deletion of a tool and their all links, an access violation or freezing occur when closed the program.

- [Brush Tools] If [Put the brush circle at stabilized coordinate] in [Preference] in [Options] dialog is turned on,
  the brush circle, guide lines and strokes will be delayed.


[Changes]

- [Tool Settings Files] Changed not to report an error even if a settings file with an unacceptable name exists.

- [Brush Tools] Re-tuned the tapering at the stroke end in stroke stabilizer S-1 to S-7.


--------------------------------------------------------------------------------------------------------------------------------------------
2021-07-06

[Fixed Bugs]

- [Shortcut Keys dialog] Shortcut assignments for tools and tool groups are not applied immediately.


[Changes]

- [Move Tool] Added [Pick Layer without Mod. key] checkbox.
  (Pleae turn on this checkbox if you want to apply the bug fix of Move Tool in 2021-07-03)


--------------------------------------------------------------------------------------------------------------------------------------------
2021-07-03

[Fixed Bugs]

- [History] In rare case, access violations occur when paint by a brush tool immediately after erasing the layer image outside canvas.

- [Brush Tools] Brush forms and brush textures are not applied when start the program with the user interface panels hidden.

- [Brush Tools] If [Put the brush circle at stabilized coordinate] in [Preference] in [Options] dialog is turned on,
  the brush circle will stop moving if draw stroke quickly and stop it.

- [Move Tool] "Pick Layer" does not work without Ctrl key if [Pick Layer by Ctrl+LeftClick] is turned on.
  (This function was worked on earlier preview versions)

- [PSD Format] Illegal folder group closing information are outputted.
  (For example, the PSD files created by SAIv2 are unable to open by ImageMagick etc.)


[Changes]

- [Tool Selection] Changed tool selection by a shortcut key to circulate tools assigned the same shortcut key.

- [Tool Group] Changed to be able to select a tool group by shortcut key.

- [Shortcut Keys dialog] Implemented assignment of tools(contains tool groups) again.


--------------------------------------------------------------------------------------------------------------------------------------------
2021-05-28

[Fixed Bugs]

- [Show Alone Layer] It disappears when the child layer of the clipping group is set to [Show Alone].

- [Recover Work] In rare case, access violations occur after opened [Recover Work] or closed the program.


--------------------------------------------------------------------------------------------------------------------------------------------
2021-02-28

[Fixed Bugs]

- [Blur Tool] The settings for scattering form and [Tool Preference] are not saved.

- [File Viewer] After deletiing 'Current Folder', an access violation occurs when changing the item selection in 'File List' with keyboard.


[Changes]

- [Show Alone Layer] Changed the layer visibility operation for descended layers of [Show Alone] layers to the normal visibility change.
  (The same mention in 2020-08-28 was wrong)

- [PSD Format] Changed to convert the single color 'Background' in PSD to [Canvas Background] on SAIv2.

- [Linework Layer] Changed the moving granularity of binary strokes to pixels.


--------------------------------------------------------------------------------------------------------------------------------------------
2020-11-28

[Fixed Bugs]

- ["Brush" and "Water Color"] The painting result near the intercection of strokes will be currupted when a symmetric ruler is enabled.

- [Binary Pen / Binary Eraser] [Algorithm] is not applied.

- [Import settings from Ver.1] Unable to import tool settings for linework layer.


[Changes]

- [Bristle] Changed the direction detection distance for a large bristle to shorten when the view magnification is less than about 25%.

- [Linework Layer] Reduced vibration of the entire stroke when moving the first control point of a binary stroke


--------------------------------------------------------------------------------------------------------------------------------------------
2020-08-28

[Fixed Bugs]

- [Brush Tools] Stroke tracking also stops if stop the pen while drawing with the stroke stabilizer set to a strong level.
  (It was a side effect of the stroke distortion correction)

- [Bristles] Small bristles will be dappled with brush textures.

- [Eraser Tool] Stroke stabilizer settings does not display in the tool property dialog.

- [Eraser Tool(for Linework)] [Brush Size] is reverted to 1.0 when restarted program even if set less than 1.0.

- [Eraser Tools(for Linework)] The settings of [Vectorize] is not saved.

- [Eraser Tools(for Linework)] a stroke error may occur when opening the canvas
  if erased strokes with [Pressure CP] off and saved the canvas including those strokes.

- [File Viewer] Cannot save a canvas into directly under a junction.

- [Asset Manager] Access violations occur when delete assets other than tools.

- [Pen Tablet Control] The pressure sensitivity is disabled in the first stroke after operated a separated panel.

- [Pen Tablet Control] Shortcuts are not blocked while using the tail switch assigned to a side switch of a pen.


[Changes]

- [Show Alone Layer] Changed the layer visibility operation for descended layers of [Show Alone] layers to the normal visibility change.

- [Eraser Tools(for Linework)] Changed the initial setting of [Detect Intersections From] to [Erase Target] from [Current Layer].


--------------------------------------------------------------------------------------------------------------------------------------------
2020-06-17

[Fixed Bugs]

- [Brush Tools] The pressure sometimes increased when draw a short stroke if [Direction] or [Angle Control] is [Auto].

- [Swatch] Changing the slot size is not saved.

- [Layer] [Show Alone Layer] is not removed by [Change Visibility of Layer] shortcut.


[Changes]

- [Brush Tools] Changed to be able to draw a very short stroke even if [Direction] or [Angle Control] is [Auto].

- [Layer Panel] Changed [Clipping Group] checkbox always enabled even if parent layer is invisible.


And some other minor bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2020-05-10

[Fixed Bugs]

- [Program Termination] Access violations occur when cancel PC Shutdown or Sign Out while running SAIv2.

- [Asset Maneger] Access violations may occur when deleting and creating groups and closing the dialog.

- [Brush Tools] The end of the stroke is little longer than the previous version.

- [Blur Tool] [Blur Width] is not saved.

- [Transform] [Resample Settings] changed during transformation is not saved.


[Changes]

- [Custom Tool Creation Menu] Discontinued [Move] button in [Existing Tools] tab.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2020-04-10

[Fixed Bugs]

- [Import settings from Ver.1] Ver.1 fails loading of settings if Ver.2 is running after importing.
  (The settings of Ver.1 are recovered when close Ver.2 and restart Ver.1)

- [Layer List] When the list is scrolled and there is a bottom margin, the list slips down 1px each time you switch the current layer etc.

- [Brush Tools] Even if changed the brush size to 500 or more, the brush size revert to 500 when restarted SAI.

- [Brush Tools] The stabilizer setting is reset when duplicate a tool.

- [Brush Tools] Bristle strokes begins slightly thicker even if [Min Size] is 0.

- [Linework Layer] Control points may not be editable.

- [Window Control] SAI freezes when the desktop resolution is changed while using File Viewer.

- [Multi-Core Processing] The program will not work properly if there are more than 32 cores.


[Changes]

- [Brush Tools] Tweaked the texture effect on thin brushes to be more natural.

- [Brush Tools] Tweaked the drawing result of bristles closer to Ver.1.

- [Brush Tools] Added setting to disable correction of stroke distortion added in 2020-01-19 version to sai2.ini.
  ([PenTablet] -> DisableAntiStrokeDistortion)


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-25

[Fixed Bugs]

- [Import settings from old Ver.2] Importing is failed if the import source does not inluced "brshape" and "scatter" folder.

- [Weight Tool] Does not work.

- [Filter: Gaussian Blur] Access violations occur when started and canceled gaussian blur while floater existing.

- [Configure Canvas Size Presets] Reordering does not work correctly if the size list is scrolled.

- [Asset Maneger] In the group list or the item list, reordering does not work correctly if the list is scrolled.


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-19

[Fixed Bugs]

- [Common Tool Property] The change of shortcut key is not saved at the end of program.

- [Tool Selection] The shift behavior is not blocked during drag operations.

- [Brush Tools] The tail of stroke is cut off if the stabilizer mode is [Ver.1 Mode].

- [Brush Tools] A stroke is distorted on a part that packet intervals of a pen tablet are uneven

- [Blur Tool] The settings of brush form and brush texture are not saved at the end of program.

- [Options Dialog] An access violation occur when changed [For layer blending modes, use common names instead of SAI dialect]
  if any canvas does not exist.


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-13

[Fixed Bugs]

- [Image Asset] Access violations occur if displayed an asset list including images that the aspect ratio is so large.

- [Asset Manager] The order of items in [Unorganized] group is no saved.

- [Shortcut Keys] The function assignments are not saved at the end of program.


[Changes]

- [Import settings] Added the mentions of version range of SAI that can be imported into the texts on the dialog.
  (Ver.1 is Ver.1.0.2 or later, Ver.2 is 2015-04-24 to 2019-08-12)

- [Asset Manager] Added the features of renaming and deletion for swatches and scratch pads.

- [Asset Manager] Added the management features for custom tools.
  (For groups: Create/Delete/Rename/Reorder, For tools: Delete/Reorder/Inter Group Move)


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-08

[Fixed Bugs]

- [Scattering Tool] The scattering parameters is reset when select a Scattering tool that is selected [Simple Circle] form.

- [Tools] An access violation occur when duplicated a Bucket tool or a Gradation tool.

- [Import settings] Unable to import the canvas preset settings of old SAI Ver.2 correctly.

- [History] Unable to undo or redo some data of layer mask, text layer, ruler layers and layer folder.


And some other some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07c

[Fixed Bugs]

- [Linework Layer] Access violations occur if drew a stroke that has single control point.

- [Weight Tool] The stroke parameters are reset when used.

- [Binary Brush Tools] Unable to apply pressure for brush size.


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07b

[Fixed Bugs]

- [Import settings] Unable to import the tool settings of old SAI Ver.2 correctly.

- [Linework Layer] Access violations occur when drew a stroke.


[Changes]

- [Tool Panel] Changed the order of [Tool Preference], [Reserve Settings] and [Recall Settings] button.


--------------------------------------------------------------------------------------------------------------------------------------------
2020-01-07

 * Caution! : Recovery data created by this version is not compatible with older versions.

The path of settings folder is changed to "<(My)Documents>\SYSTEMAX Software Development\SAIv2".
Brush forms and textures are stored into this folder from this version.

And, the folder structure of Zip archive is changed as the following.
Old versions cannot run in the newer folder structure.

  +init
    +blotmap
    +bristle
    +brshape
    +brushtex
    +papertex
    +scatter
   sai2.exe
   sai2.ini


[New Features]

- Settings Import Feature for Old Versions
  (The settings import dialog will be displayed if the settings folder is not existing when SAIv2(2020-01-07 or later) started.)

- Reserve and Restore feature for tool settings.
  (Buttons at the bottom left of the tool panel)

- Grouping Feature
  The grouping feature is provided for the following features.
  + Tool
  + Brush Form
  + Brush Texture
  + Swatch
  + Scratch Pad

- Asset Maneger(Provisional implementation)
  (For groups: Create/Delete/Rename/Reorder, For assets: Reorder/Inter Group Move)

- Blur Tool

- Binary Tools
  For normal layer: [Binary Pen], [Eraser], [Selection Pen], [Selection Eraser]
  (The name of previous [Binary Pen] is changed to [Pixel Art Pen].)

  For linework layer: [Pen], [Eraser], [Curve], [Weight]

- Color History
  (Added into the swatch panel)


[Fixed Bugs]

- [Brush Tools] Brush density cannot be easily controlled.

- [Brush Tools] Distortion occurs near the beginning of the stroke when the stroke stabilizer is increased.

- [Brush Tools] Strong unevenness occur in color mixing.

- [Outline][Dilate/Erode Selection] An access violation occurs when layer image is completely outside the canvas.


[Changes]

- [Brush Tools] Sepalated the burush miscellaneous panel.
  (A button at the bottom right of the tool panel)

- [Brush Tools] Tuned the quality of small blotmap brush(0～6px) again.

- [Brush Tools] Added the stroke stabilizer mode.
  (This setting same as [Adjust the feeling of brush stroke end in stabilizer 1-15 to similar to Ver.1].)

- [Brush Tools] Discontinued the special behavior when [Dilution] is 0 and the painting color is transparent.

- [Brush Tools] Improved the quality of bristle.

- [Brush Tools] Added [Scrach] slider instead of [Scrach] checkbox for brush texture.

- [Shortcut Keys] Discontinued the key assignment for tools temporarily.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2019-08-12

[Fixed Bugs]

- [Symmetric Ruler] Cnannot convert symmetric shapes to regular shapes correctly by [Convert Symmetric Shapes to Regular Shapes].

- [Lasso Tool] Cannot create a traiangle shape in the polygonal mode.

- [PSD File] Cannot open a PSD file including folder structures deeper than 5 levels.
  (There is a possibility that this fix does not work because this problem was fixed under an unknown PSD specification.)


--------------------------------------------------------------------------------------------------------------------------------------------
2019-08-07

[Fixed Bugs]

- [Marker] (32bit ver. only) Does not work correctly.

- [Symmetric Ruler] The angle of point symmetric drawing is not correct.

- [Symmetric Ruler] The affection of [Scattering] parameter of scattering is not symmetry.

- [Symmetric Ruler] Access violations occur when uses Smudge tool with a brush texture.

- [Perspective Ruler] The detection button of the red vanishing point is disabled for 1VP and 2VP perspective ruler.

- [Linework Layer] Strokes are not rendered correctly.


[Changes]

- [Symmetric Ruler] Changed to render shapes of bristle and scattering as line symmetry.

- [Linework Layer] Improved rendering speed for multiple strokes operation.


--------------------------------------------------------------------------------------------------------------------------------------------
2019-07-29

[Fixed Bugs]

- [Scratch Pad] The program does not start with an error if the saved file of scratch-pad is not existing.

- [Linework Layer] Often create incorrect srokes. (An stroke error will occur when opened *.sai2 file that included these strokes).

- [Symmetric Ruler] Cannot draw correctly if the ellipse ruler is turning on.

- [Symmetric Ruler] The shape directions are not symmetric.

- [Marquee Tool / Lasso Tool] The intersection operation(Alt + Shift) does not work correctly.


--------------------------------------------------------------------------------------------------------------------------------------------
2019-07-28

 * Caution! : Recovery data created by this version is not compatible with older versions.

[New Features]

- Symmetric Ruler
  + This ruler can be created from the menu of perspective ruler on the layer panel.

  + Supported line symmmetry and point symmetry drawing. The maximum number of division is 20.

  + This ruler is applicable to drawing on a linework layer, but each mirrored stroke does not have a substance.
    [Convert Symmetric Shapes to Regular Shapes] in [Layer] menu converts mirrored strokes to regular strokes.


[Fixed Bugs]

- [Scattering Tool] Cannot paint to the scratch pad.

- [Scattering Tool] An eraser mark is not added to the mouse cursor even if the current color is transparent.

- [Brush Tools] [Preserve Pixel Opacity] in an ancestor folder is not applied to brush painting.

- [Binary Pen] The size of brush circle react to the pen pressure even if [Algorithm] is [Simple].

- [Eraser Tool(for Linework)] The program sometimes freezes when erase some particular stroke.

- [Linework Layer] The rendering result of a layer paper is different from older version.

- [Shape Layers] The hitting range of a control point is large than Ver.1.

- [Options Dialog] The program fails to start if specified an invalid path for the path of recovery data.


[Changes]

- [Layer] Show Alone mode is changed to chase a current layer among only sibling layers.

- [Brush Tools] Tuned the quality of small blotmap brush(0～6px).

- [Brush Tools] Added again [Angle] and [Angle Jitter] to the scattering form of the regular brushes.

- [Scattering Tools] Changed to apply the gaussian method to the shape size.
  (Render near shapes large and render far shapes small)

- [Scattering] Changed to apply the horizontal direction of view to [Angle] if [Angle Control] is [Pen Direction].

- [Eraser Tool(for Linework)] Added the option of multiple linework layer erasing.

- [Lasso Tool] Added [Polygonal + Freeform] mode.

- [Marquee Tool / Lasso Tool] Added the mode to intersect a selection (Alt + Shift)

- [Perspective Rulers] Changed to preserve the settings of vanishing point detection into the each ruler.

- [Perspective Grid] Changed to preserve the settings of grid snap and vanishing point detection into the each ruler.

- [Change Canvas Resolution] Changed the behavior of [Printing Resolution] to affect [Width] and [Size]
  when the size unit is "%" or "pixels" too.

- [Pen Tablet Control] Changed to suppress WinTab errors of malfunctioning driver.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-21

[Fixed Bugs]

- [Scattering Tool] Shapes that the ordinal is greater than the number of brush forms of other tools do not work.


[Changes]

- [Pen Tablet Control] Changed to get not the button mapping of pen other if the mode is Ver.1 compatible.
  (To avoid a bug of Wacom driver that WinTab errors occur when activated the program window)


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-19

[Fixed Bugs]

- [Brush Tools] [HQ Sampling] of scattering form does not work

- [Brush Tools] An access violation occurs if [HQ Sampling] of scattering form is OFF and the brush size is small.

- [Brush Tools] The names of scaling quality of scattering from is not [HQ Down Sampling].

- [Marker] The brush form does not work.

- [Scattering Tool] The selection of [Angle Control] dropdown list is not correct.

- [GUI Control] Access violations occur when shape layers was deleted by Undo of Redo.


--------------------------------------------------------------------------------------------------------------------------------------------
2019-05-18

 * Caution! : Recovery data created by this version is not compatible with older versions.

[New Features]

- Effect Pen
  This brush tool blends a stroke like layer blending. Supports layer blending modes as paint modes.

- Scattering Tool
  This brush tool is dedicated to scattering. Supports layer blending modes as paint modes.
  The scattering function of brush form was simplified because the scattering tool added.


[Fixed Bugs]

- [Canvas] Access violations occur in a rare case.

- [Recover Work] An empty selection is created if redo data does not include selection operations.

- [Brush Preview] Sometimes access violations occur if UI scaling is 200%.

- [Layer Mask] The blending result of 'Shade', 'Shine', 'Shade/Shine', 'Burn', 'Dodge' and 'Burn/Dodge' are different from Photoshop.

- [Layer Select & Move] Disabling of layer mask is not applied to Layer Select & Move.

- [Rulers, Transform] The guide is not moved in integer coordinates when moved the whole of guide.

- [Window Control] Unable to operate scroll bars and dropdown lists, by touch operation.


[Changes]

- [Brush Tools] Improved the precision of drawing lines that the logical line width is less than 1px.

- [Brush Tools] The setting to render blotmap like Ver.1 added.

- [Brush Tools] Inversion features for blotmap and texture added.

- [Marker] Improved all.

- [Layer List] Changed to be able to deselect the current layer in multiple selection.

- [Layer] Layer blending modes are reconsidered.
  'Linear Burn', 'Linear Dodge', 'Linear Light', 'Color Burn', 'Color Dodge', 'Vivid Light' are removed
  from the default setting of blending modes.
  'Hard Mix' and 'Difference' are changed like 'Transparent Shapes Layer' on Photoshop is unchecked.
  The old blending modes are able to revive from [Options] dialog -> [Preference] page -> [Layer] section.

- [Layer] Show Alone mode is changed to chase a current layer.

- [Options Dialog] Changed to apply [Minimum Pressure] to all pen tablet control modes.

- [Options Dialog] The following settings added.
  + Process priority of SAI
  + The path of recovery data and image thumbnails cache.
  + A few settings about layer blending modes
  + A few settings about view

- [Pen Tablet Control] Changed to not handle WM_POINTER messages of pen in WinTab API mode.
  (WinTab events conflict with WM_POINTER messages by a bug of Wacom driver)

- [Pen Tablet Control] Changed to ignore multiple events of a pen press.
  (Because XP-PEN Artist 15.6 Pro sends multiple pen press events without pen release)


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2019-01-29

[Fixed Bugs]

- [File Viewer] Sometimes access violations occur.

- [PSD File] The Unicode alpha channel name is not terminated by a null character.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-23

[Fixed Bugs]

- [Scattering] Some parameters do not work.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-17

[Fixed Bugs]

- [Brush Tools] In almost cases, bristles are painted as transparent color.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-12-16

[Fixed Bugs]

- [File Viewer] The extension is added needlessly in renaming if registered extensions are hidden on the Windows setting.

- [SAI2/PSD File] The maximum layer number is 8189, not 8190.

- [Canvas] Access violations occur when closed canvas if many layers existed and floaters or layer masks existed.

- [Recover Work] Access violations occur if opened a SAI2 file that included a floater of layer mask.

- [Recover Work] Access violations occur if recovered a work that included a floater of layer mask.

- [Layer List] Changes of moving group are not applied immediately.

- [Change Canvas Resolution] Garbage appears on just outside canvas if [Resampling Method] is [Nearest Neighbor].

- [Selection] If selection exists, An access violation occurs when received a mouse coordinate that pointed outside screen.

- [Brush Preview] The preview is not updated through the change of brush size with Ctrl + Alt + drag.

- [Brush Tools] The blending of the current color is wrong when the pen pressure is weakened.

- [Brush Tools] The usage of the pen pressure is wrong when the current color is transparent.

- [Gaussian Blur] faint ghosts appear when blurred widely.


[Changes]

- [Brush Tools] Tuned the strength of blending.

- [File Viewer] Changed the rule for the initial path when opened File Viewer.

   Old rules:
   + Shared a path between [Open], [Save] and [Export].

   + For [Open] and [Save], If the current canvas has a saving path, open the saving path.
     For [Open] and [Save], If the current canvas has not a saving path, open the last path.
     For [Export], always open the last path.

   New rules:
   + Shared a path between [Open][Save], but [Export] has a path independently.

   + For [Open], [Save] and [Export], If the current canvas has a saving path, open the saving path.
     For [Open], [Save] and [Export], If the current canvas has not a saving path, open the last path.

   + Added settings about the initial path. ([Help] -> [Options] -> [Preference])


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2018-10-28

[Fixed Bugs]

- [Change Canvas Resolution] Always access violations occur.

- [Brush Preview] The visibility setting is not preserved correctly.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-10-27

[Fixed Bugs]

- [Transform] Access violations occur when [Resample Settings] is 'Bilinear' and the canvas width or height is 2^n-1.

- [Linework Layer] Stroke parameters are corrupted when transformed strokes or deleted control points.

- [Water Color] Strange color appears when [Dilution] is 0 and painted with lower pressure.

- [Scattering] Cannot paint with correct density by Marker tool.

- [Pressure Tool] Cannot change the pressure correctly when added a pressure control point and drag it immediately.

- [Brush Tool Panel] The layout in separated tool panel is not changed immediately when changed the brush form.

- [Window Control] The vertical size of a window is not maximized when double-clicked the top or bottom edge of the window.

- [Syringe] The picked color is not applied to gradation or text layer.


[Changes]

- [Brush Tool Panel] Added a setting into [Window] Menu to display size list items in only numerals.

- [Brush Tool Panel] Added a setting into [Window] Menu to display size list on upper side.

- [Layer List etc.] Expanded the drag detection distance to 150%.

- [Scratch Pad] Changed to be able to pick a color when selected a tool other than brush tools.

- [Gradation Tool] Improved the dithering.

- [Straight Ruler] Changed to be able to rotate the ruler with 'Ctrl + Drag' outside ruler body.

- [Perspective Ruler] Changed the initial position.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2018-09-20

[Fixed Bugs]

- [System File Dialog] An access violation occurs when open System File Dialog.

- [Layer List] Program freezes when dragged layer items to outside of the layer list.

- [Scattering] Access violations occur when changed [Size Jitter].

- [Scattering] [Size Jitter] is applied to the upscaling side too. (It should be applied to only the downscaling side)

- [Scattering] The minimum value of [Scattering] is 1%. (It should be 0%)

- [Brush UI Panel] The layout of the tool panel is not changed immediately when opened or closed a pane.

- [Brush Tools ] The center of size circle slipped out when resizing brush size relatively by Ctrl+Alt+drag.


[Changes]

- [Brush Preview] A new background color added. (The background color is changed with a click)

- [Scattering] Added some parameters for the scattering in the brush forms.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-09-17

[New Features]

- Per-Monitor DPI support (Windows 8.1 or later)

- Scattering as brush forms (Provisional implementation)

- Brush preview
  (The preview is able to show/hide with [Show User Interface Panel] in [Window] menu)


[Fixed Bugs]

- [Transform] Access violations occur if showed or hid selection while transformation.

- [Gradation Tool] An access violation occurs when some rulers are enabled.

- [Brush Tools] Density 

- [Linework Layer] Bezier handles are selected by [Select Strokes with Selection].

- [View] The brush size circle disappears when changed a view by shortcut key.


[Changes]

- [Brush Tools] Adjusted the feeling of brush density when [Ver1 Prs Spec] is enabled.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2018-06-14b

[Fixed Bugs]

- [Brush Tools] The program sometimes freezes when using brush tools.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-26

[Fixed Bugs]

- [Resize Canvas] Internal data are corrupted when other canvas was closed after expansion of canvas size.

- [Selection] Old selections are not deselected when do [Select All].

- [View] The layouts of embedded views are corrupted after activated a floating view and next closed an embedded view.


[Changes]

- [Multicore Operation] Modulated the priority of each thread.

- [Bristle] Re-tuned the quality and speed of the painting.

- [Bristle] Improved the detection of turn.

- [Brush Tools] Changed to apply [Blend] instead of [Dilution] to transparent color painting.
  (Changed to the behavior same as Ver.1.)

- [Options Dialog] Added a checkbox [Do not hide separated panels when turned off [Show All User Interface Panels]].


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-07

[Fixed Bugs]

- [Draw Outline] An access violation occurs when apply to different canvases.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-06

[Fixed Bugs]

- [Memory Management] Sometimes the usage of one CPU increases to around 100% after painting, layer moving and etc..

- [Layer Mask] A few errors occur when cut away a floater with selection and move it.


[Changes]

- [Dropdown List] Changed the detection method of cancel to not use mouse capture.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-05-02

[Fixed Bugs]

- [Memory Management (Only 64bits Version)] On Windows 10 1803, mass memory is allocated from start of program.
  (The cause: Windows 10 1803 reserves mass virtual address space from start of program.)

- [Window Control] On Windows 10, A windows is not activated when click a scrollbar by mouse(includes WinTab).

- [View] On Windows 10, the first click by mouse(includes WinTab) is ignored after a window is activated.

- [Floating View] IME is always enabled on views.

- [Magic Wand and Bucket Tool] A selection or a painting leaks onto border lines when [Selection Mode] is [Similar Colored Area].

- [Draw Outline] Cannot apply to layer masks.

- [UI] Some UI parts(The erase button etc.) are grayed incorrectly.

- [System ID Dialog] Does not reject inputs by IME.


[Changes]

- [PSD File] Changed to accept layer folders that have image data.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-30

[Fixed Bugs]

- [Configure Canvas Size Presets] The scrollbar for size presets is not displayed.

- [View] The context menu function on the view bar is always applied to the active view.

- [Water Color] An access violation occurs when applied a blot-map.

- [Syringe] Cannot pick a correct color in a merged image when the canvas background color is transparent.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-29

[Fixed Bugs]

- [Pen Tablet Control] Cannot operate non-client area by mouse(included mouse events that generated by WinTab) on Windows 10.

- [Marker] Blot-maps do not work.


--------------------------------------------------------------------------------------------------------------------------------------------
2018-04-28

[Fixed Bugs]

- [Canvas Save] If the filename included ":", the canvas is saved as "Alternate Data Stream" of NTFS.

- [Change Canvas Resolution] The printing metrics is not calculated when [Fix Horizontal and Vertical Pixels] is checked.

- [View] Access violation occurs when changed the resolution of monitor.

- [View] The activation status of a floating view is not controlled correctly.

- [Text Layer] The keyboard focus is lost when changed a current layer from a text layer by undo, redo, Ctrl+Shift+LayerClick or etc..

- [Ruler Layers] All rulers are displayed when undo or redo [Change Canvas Size].

- [Layer Mask] The thumbnail of layer mask is not updated when changed the parent of a layer mask.

- [Bucket Tool] [Ignore Existing Selection] always work even if unchecked it.

- [Layer Select & Move] Parts that hid by layer masks are selectable.


[Changes]

- [New Canvas] Added configuration features for size presets.

- [Filename Input] Changed to block forbidden character codes of filename.

- [Brush] Changed initial parameters.

- [Water Color] Improved the painting quality.

- [Marker] Improved the painting quality to similar to Ver.1.

- [Marker] Changed initial parameters.

- [Pen Tool] Added a setting to adjust the removal range of hooks at the both ends of a stroke.

- [Magic Wand and Bucket Tool] Modified the algorithm for [Transparent Area].

- [Pen Tablet Control] Improved the operation feelings of the pen input, for Windows 8 or later.
  (Changed to ignore the Microsoft WinTab driver. For a while, changed to ignore the gesture on view windows.)

- [Memory Management] Improved the management of reserved memory.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-27

[Fixed Bugs]

- [Shape Layers] Pressure CPs and bezier handles are displayed in the view scale.

- [Copy Layer] Both of the origin layer and the copied layer are selected after the copy.

- [Fringe/Layer Paper] Sometimes access violations occur when [Layer Effect Color] is [Ver.1 Like].

- [Recovery Work] An access violation occurs when the selection is invisible at the recovery point.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-21

[Fixed Bugs]

- [Selection] Becomes unable to use SelPen and SelErs by the caution for an invisible layer when deselected hidden selection.

- [Tool Shift] Sometimes a key is ignored when pressed the key and a tool shift key at the same timing.

- [Copy Layer] When copied a layer folder that has an independent moving group, the copied group is merged to the original group.

- [Canvas] An access violation occurs when closed a deactivated canvas by a shortcut key.

- [Text Layer] The caret position is not recovered by Undo or Redo.

- [Syringe] If the background of a canvas is transparent, the syringe picks white instead of transparency when used the syringe near a painting.

- [Syringe, Select and Move Layer] Layer mask is ignored.

- [PSD File] An access violation occurs when saved a canvas that included small transparent shapes.


[Changes]

- [Bristle] Improved the sensitivity of splitting of hairs when a stroke turned back.

- [Select All] For a shape type layer, changed to select all CPs. For a text layer, changed to select all text.

- [Magic Wand and Bucket Tool] Added a checkbox to ignore the existing selection(or painted parts) from the searching of a region.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-12-01

[Fixed Bugs]

- [Recovery Work] Layer information are not appeared correctly to the layer list in some cases.

- [Layer] Access violations occur when opened a *.sai file that included layers that the length of layer name is zero.

- [Tools] The stroke stabilizer of level 10 is always applied to tools other than brush tools.

- [Brush Tools] Water fringes are not updated when the brush size is smaller than 64.

- [Lasso Tool] Curve interpolation is not applied to Lasso tool.


[Changes]

- [Brush Tools] Changed to display an additional brush circle of maximum size when not stroking.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-28

[Fixed Bugs]

- [Layer Folder] Cannot cut, move and transform child invisible layers with selection region.

- [Layer Folder] [Lock] for pixel opacity does not apply to child layers.


[Changes]

- [Layer Processing] Modified the rule for invisible layers processing and modified associated settings in [Options] dialog.
　(Those modification are applied to Cut, Move, Transformation, Rasterization and Color Adjustment)


And some other small changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-27

[Fixed Bugs]

- [Layer Merge] An access violation occurs when merges a layer folder and child layers.

- [Layer Merge] The result becomes rasterized when a shape type layer of a parent of a clipping group merged to a shape type layer.

- [Concentric Ellipse Ruler] The guide disappears when rotate or flip the ruler.

- [Concentric Ellipse Ruler] Straight lines appear when made a stroke as crossed the ruler.

- [Perspective Grid] The guide does not rotate when rotated the ruler if the snap mode is [None].


[Changes]

- [Layer Folder] Enabled again painting operations for child layers when a layer folder is selected.

- [Transform] Added an option to keep line width of ink strokes.

- [Options Dialog] Added some options into [Preference].

- [Settings File] Improved the recovery logic when the settings file was corrupted.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-24

[New Features]

- Parallel Line Ruler, Concentric Ellipse Ruler, Vanishing Point Ruler


[Fixed Bugs]

- [Brush Tools] Blotmap does not work.

- [Transform] Reverse and Rotate 90deg. for floater do not work.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-23c

[Fixed Bugs]

- [History] Access violations occur when undo or redo painting.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-23

[Fixed Bugs]

- [Linework Layer] strokes are not displayed in correct line width.

- [Perspective Grid] Program freezes if specified 0 as the division number for axes.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-11-22

[New Features]

- Smudge Tool
  (Please create Smudge Tool manually by the context menu on an empty slot of the custom tool tray)


[Fixed Bugs]

- [Ruler Layer] The UI of ruler on the quick bar is not controlling correctly if the layer panel is separated.

- [Transform] Rotation for 90deg. does not work correctly in the transformation mode.

- [Gaussian Blur] Access violations occur when changed [Preview] checkbox quickly.

- [PSD File] A corrupted PSD file is created if a layer has a name longer than 255 in multibyte encoding.


[Changes]

- [GUI Control] Changed the logic of blocking operations for file I/O or transformation etc.

- [Brush Tools] Discontinued pressure checkboxes and added pressure buttons on the left side of each slider that associated.

- [Brush Tools] Added [Anti-Ripple] checkbox that suppress ripple like artifacts on the brush stroke of a flattest large brush.
  (This feature was always enabled on the previous preview version or before)

- [Brush Tools] Improved the speed of flattest large brushes more than 15%.

- [Brush Tools] Changed the width of edge blur to same as Ver.1.

- [Brush Tools] Improved the behavior of bristles.

- [Brush Tools] Added the switch of pressure applying for [Dilution].

- [Marker Tool] Changed the density of single click painting to same as Ver.1 if [Amplify Dens.] is 100.

- [Lasso Tool] Changed to apply the stabilizer when [Selection Mode] is [Freeform].

- [Options Dialog] Rearranged categories.


And some other small changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-20

[Fixed Bugs]

- [Ver.1 Style WinTab Control] The mouse cursor is put at a different point from the drawing point, on multi-monitor environment.


[Changes]

- [Panels] Modified layout of brush tools.


And some other small changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-16

[Fixed Bugs]

- [View/Scratch pad] View and the scratch pad malfunction with particular operations


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-15b

[Fixed Bugs]

- [Initialization] Cannot start program if a file of scratch pad data is not existing.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-08-15

[New Features]

- Scratch pad


[Fixed Bugs]

- [View] Unable to select any item in the context menu on a view.

- [View] Unable to change the order of floating views by the view bar.

- [Shape Layers] Access violations occur in a rare condition about the internal memory layout.

- [Layer Mask] A thumbnail in layer list breaks when the width or the height of canvas is larger than 11585px.

- [Multicore Operation] Big delays occur when the number of logical cores is larger than 32.


[Changes]

- [Panels] Modified layout.


And some other small changes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-29

[Fixed Bugs]

- [Brush Tools] [Click Detection Pressure] of [Pen Tablet] setting in [Options] dialog does not work correctly.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-28

[Fixed Bugs]

- [Magic Wand and Bucket Tool] Does not work correctly when applied to a layer mask with [Merged Image] mode of [Selection Source].


[Changes]

- [Brush Tools] Improved sharpness of the start and the end of pressured brush stroke again.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-07-27

[New Features]

- WinTab control option same as Ver.1
  (Mouse mode same as Ver.1 became available)

- Settings for the maximum size of navigator.


[Fixed Bugs]

- [History] Closed layer folders are opened when undo or redo operation.

- [History] Does not close some history files when open, edit and close a canvas quickly.

- [Change Canvas Resolution] Change only of "Printing Resolution" does not work.

- [Change Canvas Resolution] Access violations occur when floater exists.

- [Clipboard] An access violation occurs when floater exists.

- [Separated Panels] Tool parameters are not updated with tool-shift operation.

- [Panels] Some parameters are not updated.

- [Panels] When separated navigator panel and layers panel, those layouts break if user interface was scaled up.

- [Tools] Tool selection of tail switch of stylus does not work except for normal layer.

- [Tools] Tool selection of tail switch is not independent for SelPen and SelErs. (Different from Ver.1)

- [Eraser Tool(for Linework)] Program sometimes freezes when erase straight line with [Extend To: Intersections] option.


[Changes]

- [Options Dialog] Separated pages with category.

- [Brush Tools] Changed the default value of [Amplify Dens.] to 50 from 0. (Exclude Water Color and Marker)

- [Brush Tools] Improved sharpness of the start and the end of pressured brush stroke.

- [Brush Tools] Changed the feeling of pressure sensitivity 101 to 200 of density.

- [Brush Tools] Added the option to enable similar feeling to Ver.1 stabilizer. (Options -> Tool)

- [Canvas Save] Changed the file save logic again to avoid confriction about some file synchronization program.

- [PSD File] Changed to detect blend modes of Luminosity and Shade in PSD file that created by Ver.1.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-07b

[Fixed Bugs]

- [Layer Move] An access violation occurs when moved a layer folder that specified a layer paper.


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-07

[Fixed Bugs]

- [Floating View] Strokes begin with 100% pressure after operation of other windows on SAI.

- [History] The error handling is incorrect for creation of history data file.

- [Recovery Work] SAI freezes if an error occurred in creation of a thumbnail for [Recover Work] dialog.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-06-01

[Fixed Bugs]

- [Eraser Tool(for Linework)] [Intersections] of [Extend To] does not work.

- [Magic Wand and Bucket Tool] Program freezes occasionally when [Anti-Aliasing] is enabled.

- [Syringe] Does not work on non-active view.

- [Resizing of Canvas] View is not updated when the resized canvas is placed outside view.


[Changes]

- [View] Extended the margins of canvas on the window mode a little.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-05-31

[New Features]

- Recovery function for works from crash etc.. ([File] menu -> [Recover Work])


[Fixed Bugs]

- [Recent Files] SAI ends immediately with corpulence of the recent files data.

- [View] Sometimes SAI runs out of control with an access violation after resizing of canvas.

- [View] Sometimes painting results are not applied to views other than the current view.

- [Pen Tablet Control] Sometimes mouse operation is not enabled after leaving of a pen from a tablet surface.

- [Layer Mask] The result of applying of a layer mask get corruptions partly.

- [Shape Layers] Invisible control points remained even if all control points are deleted.

- [Shape Layers] "Select Strokes with Selection" includes paths selected and deselected before.

- [Shape Layers] [Intersections] mode of [Eraer] tool detects intersections with anchor points of Bezier curves.

- [Layer List] Sometimes cannot select a current layer in a folder with shortcut key.

- [Clipboard] Clipboard data of layer mask is converted to a corrupted bitmap when ending SAI.

- [Clipboard] The blend order is reversed when multiple layer images are pasted to an other program.

- [Tool Shift] Does not detect keyup until end of drag even if upped a key immediately after the start of drag.

- [Lasso Tool] Syringe of right click does not work.

- [Shape Tool] The guide rectangle is reversed horizontally when reached to the maximum size.

- [User Interface] The content of listboxes are corrupted when changed the screen resolution.


[Changes]

- [History] The undo/redo count changed to variable count between 100 to 200(or more) from fixed count of 100.
  (Only when the recovery function is enabled. Otherwise the undo/redo count is 100.)

- [Canvas Save] Changed the file save logic to avoid confriction about some file synchronization program.

- [Layer List] Improved the operation feeling for item selection.

- [Current Color] Changed to deselect transparency when exchanged the fore-ground color and the back-ground color

- [Binary Color Effect] Change the behavior to same as Ver.1.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2017-01-19

[Fixed Bugs]

- [SAI2 file] Some internal data corrupts when saved a canvas that includes wide regions of dither pattern.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-24

[Fixed Bugs]

- [Layer] Show Layer Alone function does not work.

- [Open Canvas] A current layer is not recovered.

- [Shape Layers] When deform stroke with grabbing a curve segment, the previous CP of the curve segment is grabbing too.

- [Transform] When the resampling mode is [Lanczos 3], an error occurs when scaling down to very small.

- [Text Layer] Text color is not changed when select a color from Swatch.

- [Text Layer] When text has selection, the text color is changed even if the current tool is not Text tool.

- [Text Tool] The parameters of tool are not saved.

- [Bucket Tool] Selection is ignored for the detection of a region.

- [File Viewer] Always show Desktop when save a new canvas.

And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-12b

[Fixed Bugs]

- [Shortcut Keys] The version that you run first is "Preview.2016.12.12", An access violations occurs when open "Shortcut Keys" Dialog.
  (The shortcut key of tools will be broken if this error occured. If you obtained this error, please delete "settings2.ssd" in
  "<My Documents>\SYSTEMAX Software Development\SAI2 Demo" folder)


--------------------------------------------------------------------------------------------------------------------------------------------
2016-12-12

[Fixed Bugs]

- [Paint Engine] Access violations occur when paint something speedy on a big canvas.

- [Floater] Image data is sometimes destroyed when used brush immediately after transformation of cut image.

- [Floater] Selection is created from only the last layer when floater is created from multiple layers.

- [Layer] The preview of "Outline" does not work when floater is existing.

- [Wand Tool and Bucket Tool] Does not work for layer mask.

- [Wand Tool and Bucket Tool] Does not work on translucent region when the selection mode is "Transparent Area".

- [Marker Tool] Transparent color does not work correctly.

- [Adjustment Filter] Does not work correctly when pixels opacity of the target layer is protected.

- [JPEG Format] An access violation occurs when "JPEG Quality" dialog is opened.

- [JPEG Format] The colors of a gray scale JPEG file are converted to magenta in error.


[Changes]

- [Wand Tool and Bucket Tool] Changed to be able to use when  the target layer is invisible.

- [Create Selection by Clicking Layer Thumbnail] Changed to be able to use when  the target layer is invisible.

- [Selection] Changed to not change the visibility of the selection when the selection is invisible when Undo/Redo selecting.

- [Brush Tools] Adjusted the pressure sensitivity for brush density when "Amplify Dens." is 100.

- [Brush Tools] Adjusted the result of blot forms to similar to Ver.1.

- [Eraser Tool, SelPen Tool, SelErs Tool] Changed the default settings to ignore the pressure sensitivity. (Same as Ver.1)

- [Marker Tool] Changed the default settings; "Amplify Dens."=100, "Ver1 Prs Spec."=On.


And some other small changes and some small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-19

[Fixed Bugs]

- [Viewbar] Program freezes when dragged a viewbar item and dropped to itself.

- [Layer] Clipping group in a layer folder become disabled temporarily when show a layer folder alone.

- [Layer] Access violation occurs when try to create a perspective ruler or a perspective grid.

- [Transform] Access violation occurs when transformed an image in selection region and undo transformation immediately.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-17

[New Features]

- Reordering for viewbar items.

- Layer copy to a viewbar item from layer list.

- Context menu for viewbar item.


[Fixed Bugs]

- [Separated Panel] Separated panel is able to close by Alt+F4, and Access violation occurs when program closed.

- [View] The angle and the horizontal direction are not applied correctly for the center mark of the ellipse ruler and for pressure CPs.

- [Layer List] Cannot move a layer list item to the bottom of layer list.

- [Layer] Change of layer visibility is not appeared on navigator and other sibling views immediately.

- [Layer] Clipping group become not disabled temporarily when show a layer alone.

- [Layer] Bucket tool and Gradation tool are not blocked for a layer in a locked folder.

- [Bucket Tool] Striped garbage appears when transparent color is selected and green and blue of the current color are 0.

- [Pressure Tool] The pressure rate popup is not hidden when added pressure CP.

- [Gaussian Blur] Access violation occurs when layer image is spread outside canvas.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-12

[Fixed Bugs]

- [Separated Panels] Buttons do not work.

- [Scrubby Zoom] Sometimes does not work correctly.

- [Linework Layer] The freezing bug fixed on 2016-11-11 version is not fixed completely.

- [System File Dialog] Cannot open multiple files.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-11

[New Features]

- Separation for the user interface panels.


[Fixed Bugs]

- [View] Access violation occurs when rotated a view between 180 to 360 degrees in the following conditions;
  The vertical resolution of the screen is aligned to 32px, In the full screen mode, The user interface panels are hidden,
  The scroll bars of view are hidden

- [Linework Layer] Internal order of pressure CPs breaks when moved multiple pressure CPs.

- [Linework Layer] Program freezes for a while when erased a stroke that the above bug occurred.

- [Selection] "Dilate Selection 1px" does not work correctly.

- [Straight Ruler] "Lock Pivot" in the context menu does not work.

- [Brush Tools] Guide line from the end of the last stroke appears in the straight line draw mode when pressed Shift key.

- [Pen Tool] Last control point is always created as pointed CP.

- [Magic Wand and Bucket Tool] Access violation occurs when the selection source folder is invisible.


[Changes]

- [Layer] "Transfer Painting into Next Layer" changed to obtain same result as Ver.1.

- [Zoom Tool] [Rectangular Zoom] and [Scrubby Zoom] operations added.

- [Pressure Tool] Changed to display the puressure rate on a view.

- [Brush Tools] Changed to display the guide circle and the brush size on a view.

- [Syringe] Changed the internal background color to white when the background color of canvas is transparent.

- [Tools] Changed to assign a shortcut key as the virtual key code.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-02

[Fixed Bugs]

- [Layer] Program runs out of control when copied a layer folder that includes the current layer.

- [Brush Tools] Pressure sensitivity trackbars do not work.

- [File Viewer] Image metrics always display as 0 x 0 in "Details" mode.

- [File Viewer] Image metrics information for *.sai files are not created.


[Changes]

- [File Viewer] Changed to display the image metrics of a pointed file item.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-11-01

[Fixed Bugs]

- [Canvas] A light grayed border appears on the edge of a canvas when created selection.

- [Reverse and Rotate Canvas] Selection is ignored.

- [Layer] An ordinal of layer name is interpreted as an octal number when added '0' before ordinal. Leading '0' is removed.

- [Layer] A layer name is erased when named a layer as numerals only.

- [Selection] Selection appears as broken after moved/reversed/rotated selection and hid the selection and undo the operation.

- [Text Tool] Copy and paste does not work.

- [Eraser Tool(for Linework)] Pointed curves converted as pointed contol points.

- [File Viewer] Cannot open a folder by double click in the files list on the save mode.

- [File Viewer] Cannot open shortcut.

- [SAI Format] An error sometimes occurs when opened *.sai file.

- [Dialogs] Some dialogs are always displayed in the primary-monitor.


[Changes]

- [Layer] Changed to insert the copied layers before the current layer.

- [Layer] Changed to keep the appearance(that related to opacity and effect) of the result when merged two normal layers simply.

- [Selection] Changed to keep the invisibility of selection after moved/reversed/rotated the selection.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-10-30

[New Features]

- File Viewer


[Fixed Bugs]

- [Change Canvas Size] 'Extension for Each Side' does not work if the width and hight was not changed.

- [Floater] Program runs out of control when decided the transformation on outer of canvas.

- [Layer] Program is frozen when apply "Select CPs in Selection" or "Select Strokes with Selection" to a layer folder.

- [Layer] Some near layers are embroiled to the deletion in merging of a clipping group.

- [Layer] The visibility and the opened status is not inherited to the copied layers and folders.

- [Layer] A merged layer is inserted as wrong level if the layer is the bottom item of a folder.

- [Layer] A rasterized layer is inserted as wrong level if the layer is the bottom item of a folder.

- [Layer] The order of layers become reverse when paste the layers into a layer folder.

- [Layer] Reverse Horizontal for view does not apply to the nudge operations.

- [Layer] Perspective ruler/grid become un-deletable when create the rulers on the parent layer of clipping group.

- [Layer] Show Alone mode does not work for the layers deeper than two levels from the target layer.

- [Layer] The closed folders do not opened when selected a layer in those folders by Select & Move operation.

- [Layer] Select & Move does not work if selection is existing.

- [Layer List] The scroll position is reset when changed canvas.

- [SAI/PSD Format] The ordinal of the layer is reset when open a file.

- [Swatch] The color slots do not extend correctly.

- [Tool Shift] Tool shift takes malfunction when pressed Caps key.

- [Text Tool] Nudge does not work if the text frame has key input focus.


[Changes]

- [Layer List] Changed the design a litte.

- [Layer List] Changed the eye icon color for the ancestors and the offspring of a layer that showed alone.

- [Layer List] Changed to treat transparent color as black. (Canceled the change that applied in 2016-07-30 Version)

- [Linework Layer] Changed the behavior of the perspective parameter for transformation to similar to Ver.1.

- [Perspective Ruler/Grid] Adjusted the opacity of the guide lines.

- [Perspective Grid] Rotation operation added. (Alt + drag CP)

- [View] The setting about the scroll range of view added. (Option dialog)

- [Straight Line Mode/Gradation Tool] The snap angles for 45 degrees added.

- [Brush Tools] The operation to draw straight line added. (Shift + Click);

- [Water Color Tool] Changed the default settings to similar feeling to Ver.1 (Amplify Dens. = 0 -> 50, Ver1 Prs. Spec. = OFF -> ON)

- [Pen Tool] Changed to restrict the hook of start of stroke and end of a stroke.

- [Eraser Tool(for Linework)] The settings for Vectorization added.

- [Curve/Line Tool] Changed to back to the plot mode when undo the finish of the plot.


And some other small changes and small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2016-07-30

[New Features]

- Shortcuts for layer mask operations.


[Fixed Bugs]

- [Layer Mask] Apply button and Link button on layer list item do not work.

- [Canvas] The position of un-linked Layer mask is not moved when the canvas size was changed.

- [Selection] Some square halls appears when dilate or erode the selection.

- [Transform] When transformed layers with selection, the floaters do not come to be able to operate if the bottom floater is empty.

- [Text Tool] Access violation occurs when changed the scaling of user interface.

- [Brush Tools] Heavy delay for drawing occurs on some bristles.

- [Bucket Tool] Tile form artifacts appear when filling a region with a transparent color.

- [Color Adjustment] Preview checkbox does not affect layers other than the top layer in the multi selected layers.


[Changes]

- [Layer Mask] Changed to treat transparent color as white.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-07-27

[New Features]

- Cut, Copy and Paste operation for linework layer and shape layer.

- Shortcuts for layer attributes.

- Shortcuts for view switching.


[Fixed Bugs]

- [Navigator] The scale track bar and the angle track bar does not work correctly.

- [Navigator] The position indicater does not update.

- [Layer] Access violation occurs when operate an empty layer folder on the bottom of the layer list.

- [Layer Mask] Paint color has inconsistency if the layer mask is the invert mode.

- [Layer Merge] Access violation occurs when a clipping group includes an invisible layer.

- [Layer Merge] When merge a clipping group, invisible layers stay after merging.

- [Linework Layer] Sometimes internal selection status of paths are kept after deselection.

- [Linework Layer] After reverse or 90deg rotation, cannot operate paths.

- [Gaussian Blur] Does not apply blur correctly when pixel opacity is preserved.

- [Lasso Tool] Polygonal subtraction does not work if Alt key is not pressed when finishing plot.

- [Bucket Tool] The regions that have same color as paint color are not excluded from fill.

- [Pressure Tool] CCannot change the density pressures.


[Changes]

- [Layer Merge] The restriction about a clipping-group on multi selection is removed.

- [Brush Tools] Changed the blending operation for size circle to same operation on Ver.1.


And some other small changes and small bug fixes...


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-24

[New Features]

- Create Selection by Layer Folder

- Nudge for a transformation image by the arrow keys.


[Fixed Bugs]

- [Color Mixer] Cannot register color after picked up color from Color Mixer.

- [Navigator] The scale track bar and the angle track bar does not work correctly.

- [Canvas] Layer thumbnail breaks if the canvas size is larger than 256M pixels.

- [Canvas] Reverse Canvas and Rotate Canvas does not process layer mask.

- [Layer] Cannot transfer layer between canvases by drag and drop operation.

- [Layer] Cannot apply color adjustment filters for a layer folder.

- [Layer] Apply Layer Mask button is enabled for a layer other than normal layer.

- [Shape Layer] Cannot transform shapes.

- [Brush Tools] The sliders do not accept operation on the brush tool popup window(Ctrl+Alt).

- [Brush Tools] The dot mouse cursor is not appears for Eraser, Binary Pen and Pen tools.


[Changes]

- [Layer] Changed to be able to cut, copy and move images in a folder with selection when a layer folder is selected.

- [Layer] Select and Move Layer feature is enabled even if a selection is existing.

- [Layer] Changed to be able to select a layer by click on the thumbnail space.

- [Panels] Changed to be able to open a layer property and a tool property by a double click.

- [Fringe/Layer Paper] Adjusted the color effect.

- [Fringe/Layer Paper] "Deep" mode and "Multiply" mode added.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-20

[Fixed Bugs]

- [Recent Files] SAI stops by error when the recent files list is empty.

- [Canvas Save/Load] Canvas background color is not handled correctly.

- [SAI Floamt] Layer mask is not loaded correctly.

- [JPEG Format] Error popups appears on the bottom-right of window when try to load CMYK colored JPEG file.

- [Layer] Access violation occurs when a sole image layer is deleted.

- [History] SAI sometimes malfunctions when undo images outside Canvas.


[Changes]

- [SAI Format] Changed to display a notification when try to load *.sai file that created by SAI of the beta test age.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-06-19

[New Features]

- File format support for JPEG, PNG and TGA

- File loading support for SAI Ver.1 format(*.sai)

- HSV/HSL Slider, Color Mixer, Swatches
　(Scratch Pad will be discontinued)

- Shortcuts for layer visibility

- Shortcuts for layer item selection on the layer list

- Shortcuts for syringe

- Merge Visible Layers, Flatten Image

- Dilate Selection 1px, Erode Selection 1px

- Filters
　+ Hue/Satulation
　+ Brightness/Contrast
　+ Gaussian Blur

- Visibility option for Brush Size Circle

- Dot Cursor for Brush Tools

- Painting Mode for Brush Tools


[Fixed Bugs]

- [Recent Files] Access violation occurs about long path name.

- [Brush Tools] Rotation and Reverse of view are not applied to the direction of stylus.

- [Water Color] Blur effect does not work correctly when the brush size is smaller than 15.

- [Marker] Marker does not work correctly when the density is not 100.

- [Linework Layer] Pressure CP creation option of Pen does not work.

- [Layer Move] Rotation and Reverse of view are not applied to Layer Nudge.

- [Perspective Ruler] Creation shortcut key does not work for Perspective Ruler and Perspective Grid.

- [Marquee] Selection to top-left from bottom-right does not work.

- [Selection] Garbage appears around the bounding box of selection with dilation and erosion.

- [Change Canvas Resolution] Resolution change sometimes fails.

- [Trim Canvas by Selection] Pixels outside canvas are not cut down.


[Changes]

- [Custom Tool Tray] Changed the behavior of item drag operations to same as Ver.1.

- [Error Detection] Changed to record errors into error log.

- [WinTab Control] Changed to ignore error about inquiry for the version information.

- [Canvas] Added background color options.

- [View] Changed the maximum scale to 3200% from 1600%.

- [Layer Merge] Changed to insert a merged layer to the location that the current layer was gone.

- [Fringe/Layer Paper] Improved the color effect to avoid somberness.

- [Fringe/Layer Paper] Added "Layer Effect Color" options in Canvas menu.
  ("Vivid Fringe" was moved into "Layer Effect Color" options, and the name was changed as "Vivid")

- [Syringe] Added an option to pick up color while dragging.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-03-19

[Fixed Bugs]

- [Marker Tool] Does not work correctly.

- [sai2.ini] "AlwaysUseTabletPcApi" is specified as "y" by mistake.


[Changes]

- [Tablet Input] Changed to never load WinTab API DLL when using TabletPC API.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-03-17

[New Features]

- Binary Pen

- [Binary Color] effect
  (This effect is added into [Layer Effect] settings.)


[Fixed Bugs]

- [New Canvas] [Preset] does not work correctly.

- [Layer] Grayed status of layer attribute controls for an invisible layer are removed when selected an invisible layer.

- [Layer Mask] Creation of Selection with layer mask image does not work correctly.

- [Layer Mask] White(RGB(255,255,255)) is always used on "Fill Layer" function.

- [View] Access violation occurs when closed a view.


[Changes]

- [Brush Tools] Tuned the effect of "Amplify Density" parameter.
  (If you set 100 in "Amplify Density", the drawn line will resemble Ver.1.)

- [Brush Tools] [Ver1 Prs Spec.] parameter added.
  (If turn on this parameter, the calculation for brush density pressure is changed to the specification of Ver.1)

- [Linework Layer] Disabled the rectangular selection for pressure control points on other than pressure tool.

- [Linework Layer] Enabled the select and move function(Ctrl+Shift+Drag) on a linework layer.

- [Panels] Changed to always show a scroll bar for the color and tool pane.

- [Gradation Tool] Improved the quality of gradation.

- [Image Transformation] Restricted the ringing artifacts about pixel transparency for the bicubic and lanczos resampling.

- [Change Canvas Resolution] Changed to include the width of fringe and the scale of layer paper.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-24

[Fixed Bugs]

- [Change Canvas Resolution] The canvas size turns out as 0px x 0px when changed the printing resolution if the size unit is %.

- [Layer] SAI freezes when the scrollbar of color and tool panels switched visibility by layer change on edit.

- [Linework Layer] Pressure contol points break when connect strokes.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-23

[Fixed Bugs]

- [SAI2 File] Loading of .sai2 file fails if the .sai file includes perspective ruler or perspective grid.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-22

[New Features]

- Create canvas by clipboard data

- Recent files

- Close canvas

- Copy layer on different canvases.
  (Drag layer item to other view from the layer list)

- Reset position for view (Hand tool, Zoom tool)

- Reset angle for view (Rotate tool)


[Fixed Bugs]

- [Tool] The names is switched between Lasso tool and Magic Wand tool.

- [Layer] A layer item does not scrooll-in on the layer list by Select & Move operation.

- [Layer] Access violation occurs when transfer a linework layer or a shape layer.

- [Selection] Erosion and Dilation bring an access violation.

- [PSD File] Access violation occurs on "Change Canvas Size" dialog and "Change Canvas Size" dialog with misusing for size unit in PSD file.

- [Shorcut Key] The change for shortcut key not apply to the main menu while SAI is running.

- [Gradation Tool] After creation of a gradation tool, an access violation occurs when reverse the direction.


[Changes]

- [Gradation Tool] Improved the quality of gradation.

- [Gradation Tool] Always hit a nearest control point of the guide.


--------------------------------------------------------------------------------------------------------------------------------------------
2016-01-19

[New Features]

- [Canvas] Change Resolution

- [Canvas] Change Size

- [Canvas] Reverse Horizontal, Reverse Vertical, Rotate 90deg. CCW and Rotate 90deg. CW

- [Canvas] Trim with Bounding Box of Selection

- [Layer] Convert Luminance to Opacity

- [Layer] Transform

- [Layer] Reverse horizontal, Reverse vertical, Rotate 90deg. CCW and Rotate 90deg. CW

- [Layer] Create Selection by Layer Image
                 Ctrl + Click on Layer Thumbnail ... Replace
         Shift + Ctrl + Click on Layer Thumbnail ... Add
   Alt +         Ctrl + Click on Layer Thumbnail ... Delete
   Alt + Shift + Ctrl + Click on Layer Thumbnail ... And

- [Ruler] 2VP and 3VP Perspective Grid

- [Tool] Gradation Tool

- [sai.ini] Add settings to avoid bugs on tablet drivers.


[Fixed Bugs]

- [Mouse] Mouse wheel does not work correctly with some devices.

- [Window] Does not preserve the window size of frame window.

- [Window] High DPI monitor breaks the layout of the current colors.

- [View] Some parts of selection border sometimes disappears.

- [View] Child view sometimes stops the window painting when switch to floating view.

- [Layer] Access violation occurs when fill floating part.

- [Layer] "Select & Move Layer" includes invisible layer and hidden part.

- [Brush tools] Access violation occurs when read a bristle data includes elements more than 64.

- ["Brush" and "Water Color"] The color blending involves irrelevant colors outside brush pattern.

- [SelPen, SelErs] Ctrl+Alt(change of brush size) does not work.

- [Text Layer] Enter key does not work.

- [Text Layer] Text outside canvas sometimes disappear.

- [Perspective Ruler] Duplicated ruler does not work.

- [Ruler, Perspective Ruler] Ruler disappears when press space key.

- [Erosion, Dilation for Selection] Erosion and dilation freezes when a layer mask is selecting.

- [PSD File] "Layer opacity" on SAI is replaced by "Fill" on Photoshop.


[Changes]

- [Shortcut Key] Preserve shortcut key settings of unsupported functions.

- [Canvas] The canvas background color settings moved to menu from layer tray.

- [View] Restrict the break out of canvas from view when repeat zoom in and zoom out.

- [Pen Tablet] Support tail switch.

- [Brush Tools] "Ignore ruler mode" and "Straight line mode" buttons added into the quick bar.
  The effect keyed operation for these functions are abolished.

- [Brush Tools] Restrict pressure gain for start of brush strokes.

- [Brush Tools] The settings for direction and randomize for bristle added.

- [Brush Tools] The settings for scratch for brush texture added.

- [Brush Tools] The settings for amplification for brush density added

- [Water Color] The feeling for blur improved.

- [Marker] The quality for downward sloped density improved.

- [SelPen, SelErs] The internal density of 100% is amplified. (Same to Ver.1)

- [Canvas] The file extension for temporary file on saving process is changed.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-10-19

[New Features]

- Magic Wand and Bucket
  (Please create Bucket tool from the context menu of the custom tools tray if you have executed a older version of SAI2.)

- Lasso

- Cut, Copy and Paste for image

- Rasterization for linework layer, text layer and shape layer

- Dilation and Erosion for selection region.


[Fixed Bugs]

- "Merge Layer" obtains malfunction with layer that moved to outside canvas.

- "SelPen" and "SelErs" obtains malfunction on the right edges and the bottom edges of canvas.

- Selection region sometimes does not appear correctly when the selection display mode was changed.

- Initialization of WinTab-API fails on some tablet drivers other than Wacom.

- Enter key and Esc key do not work for Curve and Line tool after the using of Shortcut Keys dialog.

- The following layer operations do not work correctly on a canvas that loaded from *.sai2 file.
  - Open and Close for layer folder
  - Multi layers selection
  - Change for layer protections

- The context menu for shape layer tools does not include functions to create shape layer tools.

- Undo and Redo for text layer do not work if the history data was purged into storage device.


[Changes]

- Improved the behavior of Merge Layer.
  - It came to work for multiple selected layers
  - It came to merge a clipping group independently.

- It came to handle the opacity of the following blend modes as "Fill" on PSD file.
  - Shade
  - Shine
  - Shade/Shine
  - Burn
  - Dodge
  - Burn/Dodge


--------------------------------------------------------------------------------------------------------------------------------------------
2015-07-18

[Fixed Bugs]

- "Save" for any format obtain an internal error if the pixel width of the canvas is an odd number and the background color is transparent.

- "Save" for .sai2 format obtain an internal error if the canvas has layer folder.

- "Save" for .bmp format output incorrect information for the existing of the transparency.

- Undo and Redo obtain malfunction after painted layer was moved to outside canvas.

- After a layer folder integrated as a layer, "Layer Paper" of the layer disappears.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-07-10

[New Features]

- Syringe for merged image.

- Syringe for deactived view.

- Select and move layer. (Ctrl + Shift + Drag)

- Nudge for layer (Ctrl + Arrow Keys(Cut and move), Alt + Arrow Keys(Only selection), Shift key increases the stride)


[Fixed Bugs]

- The brush settings popup of Ctrl + Alt is always displaying on the view created first.

- "Open" for any format sometimes obtain a reading error.

- [Memory Usage] does not work.

- Combination of layer moves do not update the modifying state from the second moving.

- Memory starvation brings crash immediately.


[Changes]

- Renewed completely the history management for painting.

- Sped up "Open" and "Save" for *.sai2 format with the malti-core programming.

- Improved the quality of bristles instead of the speed.

- Added [Drive Space] information into the status bar.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-25

[Fixed Bugs]

- Create PSD file that is not able to read by Photoshop if an empty layer is placed under a painted layer.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-24

[Fixed Bugs]

- Protection of pixel's opacity does not work.

- Can not save and load layer masks correctly in PSD format.

- RGB values of merged image of PSD file are incorrect.

- Quick combination of "MoveLayer -> Paint -> MoveLayer" bring some malfunctions.

- Deselect region sometimes does not erase selection border.

- Undo and Redo for layer name does not work correctly.


[Changes]

- Preserve newer version's settings even if older versions is launched.
  (The path of settings file was changed. Sorry, please make your settings again.)

- Added settings to show the system menu by Alt + Space.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-22

[Fixed Bugs]

- Create PSD file that is not able to read by Photoshop

- Can not undo Bezier handles in change of path type.

- "Transfer Painting into Next Layer" function does not erase control points of paths.

-  Space + EffectKey + Drag does not work when control points is displayed.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21b

[Fixed Bugs]

- Access violation occurs when a menu is opened.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21a

[Fixed Bugs]

- The save canvas function for PSD/PSB format obtains access violations.


[Changes]

- Added new modified statuses for a canvas.
  (The statuses will appear in title bar as the following.
      * ... The canvas is not saved.
      ! ... The canvas was saved as a format other than sai2, but some SAI specific information are not saved.
      - ... Some information not recorded into History are not saved.(e.g. Layer visibility))


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-21

[Fixed Bugs]

- Curve tool and Line tool obtain an access violation from first click.

- Can not redo the duplication of paths.

- 'Select All' obtains access violations on some canvas sizes.

- History combining is not applied for moving of selection region.

- Pressure tool for densities does not work.


[Changes]

- Changed custom tool set of layer folder, text layer and perspective ruler to the set of normal layer.

- Added the prohibition cursor for unpaintable layer.

- Added specific mouse cursors for Eraser, Mask Pen and Mask Eraser.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-04-20

[New Features]

- File format support for PSD and PSB

- New layer blending modes.

- Layer mask

- Background color setting for canvas

- Shortcut key for brush tools (about size, density)


[Fixed Bugs]

- Zoom and angle track bar of the navigator drop the display result when operated quickly.

- Can not create canvas when the horizontal width is less than 32px.

- Bristle brush brings broken painting. (32bit version only)

- Some unrelated closed folders are opened when using Undo and Redo.

- The visibility settings of a 'Pass' mode layer folder does not work correctly.

- Merge for a layer folder does not work.

- System ID is sometimes changed after rebooted computer.

- Brush form and texture settings is not saved if the name included other than ascii characters.

- Combination of 'Overlay' mode and paper texture brings a broken blending result.

- Can not start program if the path of 'My Documents' was changed into a root directory.

- Canvas is closed without the confirmation dialog if it undid all operations.

- Tooltip is displayed outside of screen.


[Changes]

- Suppressed the delay of the stroke starting. (Windows 8/8.1)

- Added the settings for force using of TabletPC API.

- Changed the tool toggle function to a clear behavior.

And, adjusted some features.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-20

[Fixed Bugs]

- Loading of .sai2 file is failed in some cases.

- Can not remove shortcut key from tool property.

- Default shortcut keys are not appeared.
  (Please press [Reset to Defaults] in [Shortcut Key Assignments] dialog if you have executed a older version of SAI2.)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-19

[New Features]

- Marker tool
  (Please create Marker tool from the context menu of the custom tools tray if you have executed a older version of SAI2.)

- Navigator

- Shortcut Key Assignment dialog

- Options dialog (Minimum features)


[Fixed Bugs]

- Eraser tool does not detect an intersection of horizontal stroke and vertical stroke.

- Access violation occurs when Syringe is used in Layer Folder.

- Brush tool and Water Color tool does not blend the current color if "Dilution" is larger or equal 1.

- The program does not draw anything of the maximized normal view if Floating View is existing.

- The program does not switch control mode correctly to the mouse operation from the pen tablet operation.

- The program does not draw selection borders correctly.

- Brush tool and Water Color tool include outer pixels of the canvas for blending.

- The maximum width and height of texture 'less than 1024x1024' not 'less or equal 1024x1024'.

- The program does not detect correctly the release of multiple keys.

- The program destroys history data file in some cases.


[Changes]

- The program display a detailed error in initialization of data folders.

- Changed order of buttons in the confirmation dialog of the canvas closing to same as Ver.1.


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-02

- A first English preview version is released


[Fixed Bugs]

- The program does not detect the correct vanishing point of the stroke for perspective rulers.

- Access violation occurs when layers that is larger than the canvas are merged.

- The program hang up when particular keys are pressed.


[Changes]

- The execution filename changed to "sai2.exe" from "sai.exe".
  (This change will avoid a malfunction of Wacom tablet driver.)


--------------------------------------------------------------------------------------------------------------------------------------------
2015-01-01

[Fixed Bugs]

- The program used uninitialized pressure data to blend for Brush tool and Water Color tool.

- Access violation occurs when a second instance of the program is started.

- Bristle definition bitmaps are lacked from the distribution package.


--------------------------------------------------------------------------------------------------------------------------------------------
2014-12-31

[New Features]

- Linework layer
  + Imploved the curve algorythm.
  + Implemented the bezier curve mode.
  + Implemented erasing to intersection (Eraser tool).
  etc...

- Shape layer(Included minimum features)

- Save and Load functions for the private format(.sai2) and Bitmap(.bmp)


[Etc.]

- Many features is added into the base of the program from 2013-12-10 version.

- Many problems is fixed from 2013-12-10 version.


--------------------------------------------------------------------------------------------------------------------------------------------
2013-12-10

- A preview version is released.


--------------------------------------------------------------------------------------------------------------------------------------------
2011-10

- The development of Ver.2 is started.


